import math
import matplotlib.pyplot as plt

## input section info
fc=14.3
b=500.0
h=600.0 
as1=35.0
h0=h-as1 
area=5024.0
fy=300.0
nstep=30
## input
pp=[]
mm=[]
a1=1.0 
beta1=0.8 
kxb=0.55 
##
n1=a1*fc*b*kxb*h0
nmax=a1*fc*b*h+2*area*fy
for i in range(nstep+1):
    nu=(i/nstep)*nmax 
    if nu<=nmax:
        if nu<=n1: 
            mu=-nu*nu/(2*a1*fc*b)+(nu*h)/2+fy*area*(h0-as1) 
        else:
            l1=(beta1-kxb)/(a1*fc*b*h0*(beta1-kxb)+fy*area) 
            l2=(kxb*fy*area)/(a1*fc*b*h0*(beta1-kxb)+fy*area) 
            k1=(l1*nu+l2)-0.5*(l1*nu+l2)*(l1*nu+l2) 
            kx1= l1*nu+l2 
            mu=a1*fc*b*h0*h0*(k1)-(h/2-as1)*nu+fy*area*(h0-as1) 
        pp.append(nu/1000)
        mm.append(mu/1e6)

ratio = area*2/(b*h)*100
plt.style.use('ggplot')
plt.plot(mm,pp,marker='o')
plt.xlabel('Moment')
plt.ylabel('Axial_Force')
plt.title("PM curve, Ratio = {0:.3f}".format(ratio))
plt.show()

with open('result.txt', 'w') as f:
    for i in range(nstep+1):
        f.write('{0:.2f}'.format(pp[i])+','+'{0:.5e}\n'.format(mm[i]))